﻿Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports System.IO
Imports Microsoft.Win32
Imports System.Collections.ObjectModel

Public Class Form1
    Dim Loc As String
    Dim Time As Integer = 1
    Private WP_Aspect As Integer 'Wallpaper Aspect (Center, Stretch & Tile)
    Dim exists As Boolean = False
    Dim REG_Location As String
    Dim REG_Time As String

    Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Integer, ByVal uParam As Integer, ByVal lpvParam As String, ByVal fuWinIni As Integer) As Integer
    Private Const SPI_SETDESKWALLPAPER = 20
    Private Const SPIF_UPDATEINIFILE = &H1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Define_Settings()
    End Sub

    Sub Define_Settings()
        Time = Convert.ToInt32(Time_Limit.Text)
        Timer1.Enabled = True
        Timer1.Interval = Time * 60000
        ShowInTaskbar = False
        Hide()
        Visible = False
        NotifyIcon1.Visible = True
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim FBD As New FolderBrowserDialog
        With FBD
            .RootFolder = Environment.SpecialFolder.Desktop
            .ShowNewFolderButton = False
            .Description = "Please select the folder that contains your pictures"
        End With
        FBD.ShowDialog()
        Txt_Loc.Text = FBD.SelectedPath
        Loc = FBD.SelectedPath
        Get_Files()
    End Sub

    Sub Get_Files()
        ListBox1.Items.Clear()

        Dim List As New ArrayList 'only addes the following file types to the collection
        List.Add("JPG")
        List.Add("JPEG")
        List.Add("JPE")
        List.Add("BMP")


        For Each files In My.Computer.FileSystem.GetFiles(Loc, FileIO.SearchOption.SearchAllSubDirectories)
            Dim Ext As String = Strings.Mid(files, files.LastIndexOf(".") + 2).ToUpper

            For Each Extension As Object In List
                If Ext = Extension Then
                    ListBox1.Items.Add(files)
                End If
            Next
        Next files

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick, CTM_Change_Now.Click, TS_Change_Now.Click

        Try
            Timer1.Enabled = False
            WP_Apsect_Change()

            Dim generator As New Random 'This will choose a file at random
            Dim randomValue As Integer
            randomValue = generator.Next(0, (ListBox1.Items.Count))
            ListBox1.Items.IndexOf(randomValue)
            ListBox1.SelectedIndex = randomValue

            Dim imagePath As String = ListBox1.SelectedItem.ToString
            SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, imagePath, SPIF_UPDATEINIFILE)
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Control Panel\Desktop", "WallPaper", ListBox1.SelectedItem.ToString) 'Saves the current wallpaper so after a reboot, it is still set
            Timer1.Enabled = True

            ListBox1.Items.Remove(ListBox1.SelectedItem)
            If ListBox1.Items.Count = 0 Then
                Get_Files()
            End If

        Catch ex As Exception
        End Try

    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        Maxi()
    End Sub

    Private Sub Maxi()
        ShowInTaskbar = True
        Visible = True
        NotifyIcon1.Visible = False
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Define_Settings()
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Location", Loc) 'Save settings to the Registry
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Time", Time)
        My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "WP_Aspect", WP_Aspect)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Hide()
        ShowInTaskbar = False
        Visible = False

        Try
            If My.Computer.Registry.CurrentUser.OpenSubKey("Software\Minooch\RandomDesktop") IsNot Nothing Then
                exists = True
            End If
        Finally
            My.Computer.Registry.CurrentUser.Close()
        End Try

        If Not exists = True Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Location", My.Computer.FileSystem.SpecialDirectories.MyPictures)
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Time", 1)
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "WP_Aspect", 2)
        End If

        REG_Location = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Location", My.Computer.FileSystem.SpecialDirectories.MyPictures)
        REG_Time = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "Time", 1)
        WP_Aspect = My.Computer.Registry.GetValue("HKEY_CURRENT_USER\Software\Minooch\RandomDesktop", "WP_Aspect", 3)

        WP_Apsect_Change()
        Loc = REG_Location
        Txt_Loc.Text = REG_Location
        Time_Limit.Text = REG_Time
        Time = REG_Time
        Define_Settings()
        Get_Files()

        Dim Startup = My.Computer.Registry.CurrentUser.OpenSubKey("Software\Microsoft\Windows\CurrentVersion\Run", True)
        If Not (CType(Startup.GetValue("Random Desktop", "False"), String)) = "False" Then
            LOS.Checked = True
        End If

    End Sub

    Private Sub LOS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LOS.Click
        If LOS.Checked = False Then
            My.Computer.Registry.SetValue("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run", "Random Desktop", """" + Application.ExecutablePath + """")
            LOS.Checked = True
        Else
            Dim Startup = My.Computer.Registry.CurrentUser.OpenSubKey("Software\Microsoft\Windows\CurrentVersion\Run", True)
            Startup.DeleteValue("Random Desktop")
            LOS.Checked = False
        End If
    End Sub

    Private Sub WP_Apsect_Change()

        Dim WP_Apsect_Registry As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Control Panel").OpenSubKey("Desktop", True)

        Select Case WP_Aspect

            Case 1 'Tiled
                WP_Apsect_Registry.SetValue("TileWallpaper", "1")
                WP_Apsect_Registry.SetValue("WallpaperStyle", "0")
                rdTile.Checked = True

            Case 2 'Centered
                WP_Apsect_Registry.SetValue("TileWallpaper", "0")
                WP_Apsect_Registry.SetValue("WallpaperStyle", "0")
                rdCenter.Checked = True

            Case 3 'Stretched
                WP_Apsect_Registry.SetValue("TileWallpaper", "0")
                WP_Apsect_Registry.SetValue("WallpaperStyle", "2")
                rdStretch.Checked = True

        End Select

    End Sub

    Private Sub rdTile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdTile.Click
        WP_Aspect = 1 'Tile
    End Sub

    Private Sub rdCenter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdCenter.Click
        WP_Aspect = 2 'Center
    End Sub

    Private Sub rdStretch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdStretch.Click
        WP_Aspect = 3 'Stretch
    End Sub

    Private Sub CTM_Open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CTM_Open.Click
        Maxi()
    End Sub

End Class